var WizardController = function($scope, templateManager, $rootScope) {

	var wizard = templateManager.wizard;

	$scope.widget = templateManager.container.widgets[0];

	$scope.currentStageIndex = wizard.currentStageIndex;

	$scope.lastStep = wizard.getLastStep();

	$scope.numberOfStages = wizard.getNumberOfSteps();

	$scope.nextStage = function() {
		return $scope.next().then(function() {
			$scope.widget = templateManager.container.widgets[0];
		});
	};

	$scope.prevStage = function() {
		return $scope.previous().then(function() {
			$scope.widget = templateManager.container.widgets[0];
		});
	};

	$scope.cancelWizard = function() {
		if (wizard.onCancel) {
			wizard.onCancel();
		} else {
			var history = templateManager.historyItems;

			for (var i = history.length - 1; i >= 0; i--) {
				if (wizard.stages[history[i]] || history[i] === templateManager.wizard.name) {
					history.pop();
				}
			}
			openWindow(wizard.callerWindow);
		}
	};

	$scope.$watch("templateManager.wizard.currentStage", function() {
		wizard = templateManager.wizard ? templateManager.wizard : wizard;
		$scope.currentStageIndex = wizard.currentStageIndex;
		$scope.numberOfStages = wizard.getNumberOfSteps();
	});

	$scope.__defineGetter__('sourceActions', function() {
		return $rootScope.isPopupOpen() && $scope.widget ? $scope.widget : templateManager.container;
	});

};

ZeedhiController.controller('WizardController', WizardController);